# NOTE: gem install benchmark-ipsが必要です
require 'benchmark/ips'

Benchmark.ips do |bench|
  receiver = [*1..10000]

  enumerable_max =
    Enumerable.instance_method(:max).bind(receiver)
  array_max =
    Array.instance_method(:max).bind(receiver)

  bench.report('Enumerable#max') do
    enumerable_max.call
  end

  bench.report('Array#max') do
    array_max.call
  end

  bench.compare!
end
